from dbus.service import Object, method, BusName
from Globals import SESSION_BUS, GERMINAL_DBUS_PATH, GERMINAL_DBUS_SERVICE

class DBusService(Object):

	def __init__(self, manager):
		from dbus.exceptions import NameExistsException
		try:
			bus_name = BusName(GERMINAL_DBUS_SERVICE, bus=SESSION_BUS, do_not_queue=True)
			Object.__init__(self, bus_name, GERMINAL_DBUS_PATH)
			self.__manager = manager
		except NameExistsException:
			print "ERROR! Another instances of Germinal is already running."
			print "Cannot run more than one instance of Germinal."
			print "Killing this instance!"
			manager.quit()

	@method(GERMINAL_DBUS_SERVICE)
	def show(self):
		return self.__manager.show()

	@method(GERMINAL_DBUS_SERVICE)
	def hide(self):
		return self.__manager.hide()
