class PopupMenu(object):

	def __init__(self, germinal):
		from gtk import Menu, SeparatorMenuItem, STOCK_COPY
		from gtk import STOCK_PREFERENCES, ImageMenuItem, STOCK_ABOUT
		from gtk import STOCK_HELP, STOCK_PASTE

		menu = Menu()

		copy = ImageMenuItem(stock_id=STOCK_COPY)
		copy.connect("activate", lambda *args: germinal.copy())
		menu.append(copy)

		paste = ImageMenuItem(stock_id=STOCK_PASTE)
		paste.connect("activate", lambda *args: germinal.paste())
		menu.append(paste)

		menu.append(SeparatorMenuItem())

		preferences = ImageMenuItem(stock_id=STOCK_PREFERENCES)
		preferences.connect("activate", lambda *args: germinal.preferences())
		menu.append(preferences)

		help = ImageMenuItem(stock_id=STOCK_HELP)
		help.connect("activate", lambda *args: germinal.help())
		menu.append(help)

		menu.append(SeparatorMenuItem())

		from ..Utils import create_menuitem
		input_method = create_menuitem(string="Input Methods", stock_id=None)
		submenu = Menu()
		input_method.set_submenu(submenu)

		from gtk import IMMulticontext
		context = IMMulticontext()
		context.append_menuitems(submenu)

		menu.append(input_method)

		menu.append(SeparatorMenuItem())

		about = ImageMenuItem(stock_id=STOCK_ABOUT)
		about.connect("activate", lambda *args: germinal.about())
		menu.append(about)

		menu.attach_to_widget(germinal.terminal, lambda *args: None)

		germinal.terminal.connect("button-press-event", self.__event_cb, menu, germinal)

	def __event_cb(self, terminal, event, menu, germinal):
		germinal.response()
		if event.button != 3: return False
		germinal.response()
		menu.show_all()
		germinal.response()
		menu.popup(None, None, None, event.button, event.time)
		germinal.response()
		return False
