class Window(object):

	def __init__(self, germinal):
		window = germinal.preferences_gui.get_object("Window")
		germinal.connect("show-preferences", self.__show_cb, window)
		germinal.connect("hide-preferences", self.__hide_cb, window)
		window.connect("delete-event", self.__delete_event_cb, germinal)
		window.connect("key-press-event", self.__key_event_cb, germinal)

	def __show_cb(self, germinal, window):
		window.set_transient_for(germinal.window)
		window.present()
		return False
	
	def __hide_cb(self, germinal, window):
		window.hide()
		return False

	def __delete_event_cb(self, window, germinal):
		germinal.emit("hide-preferences")
		return True

	def __key_event_cb(self, window, event, germinal):
		from gtk import keysyms
		if event.keyval != keysyms.Escape: return False
		germinal.emit("hide-preferences")
		return True
