class Displayer(object):

	def __init__(self, germinal):
		self.__init_attributes(germinal)
		germinal.connect("show", self.__show_cb)
		germinal.connect("hide", self.__hide_cb)
		germinal.connect("quit", self.__hide_cb)
		germinal.connect("window-position-is-set", self.__set_cb)
		self.__window.connect("delete-event", self.__delete_event_cb)

	def __init_attributes(self, germinal):
		self.__germinal = germinal
		self.__window = germinal.window
		return

	def __show_cb(self, *args):
		self.__germinal.response()
		self.__window.present()
		self.__germinal.response()
		return False

	def __hide_cb(self, *args):
		self.__germinal.response()
		self.__window.hide()
		self.__germinal.response()
		return False

	def __set_cb(self, *args):
		self.__germinal.response()
		self.__window.present()
		self.__germinal.response()
		self.__window.show_all()
		self.__germinal.response()
		from gobject import idle_add
		idle_add(self.__germinal.emit, "window-is-mapped")
		return False

	def __delete_event_cb(self, *args):
		self.__germinal.quit()
		return True

	def __toggle_cb(self, germinal, *args):
		self.__germinal.response()
		germinal.hide() if self.__window.props.is_active else germinal.show()
		self.__germinal.response()
		return False
