class Bindings(object):

	def __init__(self, germinal):
		self.__germinal = germinal
		accel_group = germinal.get_data("AccelGroup")
		self.__connect(accel_group, "<ctrl>q", self.__quit_cb)
		self.__connect(accel_group, "<ctrl><shift>c", self.__copy_cb)
		self.__connect(accel_group, "<ctrl><shift>v", self.__paste_cb)
		self.__connect(accel_group, "F12", self.__preferences_cb)
		self.__connect(accel_group, "F11", self.__fullscreen_cb)
		self.__connect(accel_group, "F1", self.__help_cb)

	def __connect(self, accel_group, shortcut, callback):
		from gtk import accelerator_parse, ACCEL_LOCKED
		key, modifier = accelerator_parse(shortcut)
		accel_group.connect_group(key, modifier, ACCEL_LOCKED, callback)
		return False

	def __preferences_cb(self, *args):
		self.__germinal.preferences()
		return True

	def __fullscreen_cb(self, *args):
		self.__germinal.fullscreen()
		return False

	def __copy_cb(self, *args):
		self.__germinal.copy()
		return False

	def __paste_cb(self, *args):
		self.__germinal.paste()
		return False

	def __help_cb(self, *args):
		self.__germinal.help()
		return False

	def __quit_cb(self, *args):
		self.__germinal.quit()
		return True
