class Updater(object):

	def __init__(self, germinal):
		self.__sigid1 = germinal.window.connect("configure-event", self.__event_cb, germinal)
		germinal.connect("ready-to-quit", self.__quit_cb)
		germinal.connect_after("window-is-mapped", self.__mapped_cb)
		germinal.window.handler_block(self.__sigid1)

	def __update(self, germinal):
		window_state = germinal.window_state
		from ...Settings.WindowPosition import set_value
		if window_state in ("fullscreen", "maximize"):
			set_value(window_state)
			print "Setting Position in database: ", window_state
		else:
			position = self.__get_size_and_position(germinal)
			set_value(position)
		return False

	def __update_on_idle(self, germinal):
		from gobject import idle_add, PRIORITY_LOW
		self.__timer2 = idle_add(self.__update, germinal, priority=PRIORITY_LOW)
		return False

	def __get_size_and_position(self, germinal):
		x, y = germinal.window.get_position()
		width, height = germinal.window.get_size()
		return x, y, width, height

	def __remove_timer(self, _timer=1):
		try:
			timers = {
				1: self.__timer1,
				2: self.__timer2,
			}
			from gobject import source_remove
			source_remove(timers[_timer])
		except AttributeError:
			pass
		return False

	def __remove_all_timers(self):
		[self.__remove_timer(_timer) for _timer in xrange(1, 3)]
		return False

	def __event_cb(self, window, event, germinal):
		self.__remove_all_timers()
		from gobject import timeout_add, PRIORITY_LOW
		self.__timer1 = timeout_add(125, self.__update_on_idle, germinal, priority=PRIORITY_LOW)
		return False

	def __quit_cb(self, germinal, *args):
		germinal.window.handler_block(self.__sigid1)
		from gobject import idle_add
		idle_add(germinal.emit, "quit")
		return False

	def __mapped_cb(self, germinal, *args):
		germinal.window.handler_unblock(self.__sigid1)
		return False
