from Signals import Signal

class Germinal(Signal):

	def __init__(self, imanager):
		Signal.__init__(self)
		from ServicesInitializer import Initializer
		Initializer(self, imanager)

	@property
	def imanager(self): return self.get_data("IManager")

	@property
	def gui(self): return self.get_data("gui")

	@property
	def about_gui(self): return self.get_data("AboutGUI")

	@property
	def window_state(self): return self.get_data("WindowState")

	@property
	def preferences_gui(self): return self.get_data("PreferencesGUI")

	@property
	def window(self): return self.gui.get_object("Window")

	@property
	def terminal(self): return self.get_data("Terminal")

	@property
	def pty(self): return self.get_data("pty")

	def show(self):
		from gobject import idle_add
		idle_add(self.emit, "show")
		return False

	def hide(self):
		from gobject import idle_add
		idle_add(self.emit, "hide")
		return False

	def quit(self):
		from gobject import idle_add
		idle_add(self.emit, "ready-to-quit")
		return

	def ready(self):
		from gobject import idle_add
		idle_add(self.emit, "ready")
		return

	def copy(self):
		from gobject import idle_add
		idle_add(self.emit, "copy")
		return False

	def paste(self):
		from gobject import idle_add
		idle_add(self.emit, "paste")
		return False

	def help(self):
#		self.emit("show-user-guide")
		from Utils import help
		return help()

	def preferences(self):
		from gobject import idle_add
		idle_add(self.emit, "show-preferences")
		return False

	def fullscreen(self):
		from gobject import idle_add
		idle_add(self.emit, "fullscreen")
		return False

	def shortcuts(self):
		return False

	def about(self):
		from gobject import idle_add
		idle_add(self.emit, "about")
		return False

	def response(self):
		from gtk import events_pending, main_iteration
		while events_pending(): main_iteration(False)
		return False
