class Manager(object):

	def __init__(self):
		from DBusService import DBusService
		DBusService(self)
		from signal import signal, SIGINT, SIGQUIT, SIG_DFL
		signal(SIGINT, SIG_DFL)
		signal(SIGQUIT, SIG_DFL)
		from Germinal import Germinal
		self.__germinal = Germinal(self)
		from gobject import timeout_add, PRIORITY_LOW
		timeout_add(60000, self.__init_psyco, priority=PRIORITY_LOW)

	def show(self):
		return self.__germinal.show()

	def hide(self):
		return self.__germinal.hide()

	def quit(self):
		from os import _exit
		_exit(0)
		return

	def __init_psyco(self):
		try:
			from psyco import profile
			profile()
		except ImportError:
			pass
		return False

	def __init_i18n(self):
		from Globals import data_path
		from os import path
		locale_folder = path.join(data_path, "locale")
		# Initialize glade first.
		try:
			from locale import setlocale, LC_ALL, Error, bindtextdomain
			bindtextdomain("scribes", locale_folder)
			setlocale(LC_ALL, "")
		except Error:
			pass
		from gtk import glade
		glade.bindtextdomain("scribes", locale_folder)
		glade.textdomain("scribes")
		from gettext import textdomain, bindtextdomain
		from gettext import install, bind_textdomain_codeset
		bindtextdomain("scribes", locale_folder)
		bind_textdomain_codeset("scribes", "UTF-8")
		textdomain("scribes")
		install("scribes", locale_folder, unicode=1)
		return
