def get_current_folder(globals_):
	from os.path import split
	folder = split(globals_["__file__"])[0]
	return folder

def get_gui_object(globals_, basepath):
	from os.path import join
	folder = get_current_folder(globals_)
	file_ = join(folder, basepath)
	from gtk import Builder
	gui = Builder()
	gui.add_from_file(file_)
	return gui

def change_color(widget, color):
	colormap = widget.get_colormap()
	color = colormap.alloc_color(color)
	style = widget.get_style().copy()
	from gtk import STATE_NORMAL
	style.bg[STATE_NORMAL] = color
	widget.set_style(style)
	return

def open_storage(filename):
	from Globals import CONFIG_FOLDER
	from os import makedirs
	from os.path import join, exists
	if not exists(CONFIG_FOLDER): makedirs(CONFIG_FOLDER)
	filename = join(CONFIG_FOLDER, filename.strip("/"))
	from filedict import FileDict
	return FileDict(filename=filename)

def create_menuitem(string="", label=None, stock_id=None, image=None):
	from gtk import ImageMenuItem, Image, HBox, Label
	menuitem = ImageMenuItem()
	hbox = HBox()
	if image:
		menuitem.set_property("image", image)
	if stock_id:
		image = Image()
		image.set_property("stock", stock_id)
		menuitem.set_property("image", image)
	if string:
		_label = Label(string)
		_label.set_property("use-underline", True)
		hbox.pack_start(_label, False, False, 0)
	if label:
		hbox.pack_start(label, False, False, 0)
	menuitem.add(hbox)
	return menuitem

def quit():
	from os import _exit
	_exit(0)
	return

def init_gnome():
	from gobject import set_application_name, set_prgname
	set_prgname("Germinal")
	set_application_name("Germinal")
	return

def help():
	cwd = get_current_folder(globals())
	argv = ["yelp", "UserGuide"]
	from glib import spawn_async, SPAWN_SEARCH_PATH
	spawn_async(argv, working_directory=cwd, flags=SPAWN_SEARCH_PATH)
	return False

def fork_process():
	from os import fork
	pid = fork()
	if pid != 0: raise SystemExit
	return
