#! /usr/bin/env python
# -*- coding: utf8 -*-

def check_dependencies():
	try:
		check_python3()
		check_dbus()
		check_pygtk()
		check_vte()
	except SystemExit:
		from sys import exit
		exit(1)
	return

def check_dbus():
	try:
		import dbus
		if dbus.version < (0, 70, 0): raise AssertionError
		print "Checking for D-Bus (Python Bindings)... yes"
	except ImportError:
		print "Error: Python bindings for D-Bus was not found."
		raise SystemExit
	except AssertionError:
		print "Error: Version 0.70 or better of dbus-python needed."
		raise SystemExit
	return

def check_pygtk():
	try:
		import gtk
		if gtk.pygtk_version < (2, 16, 0): raise AssertionError
		print "Checking for PyGTK... yes"
	except ImportError:
		print "Error: PyGTK was not found."
		raise SystemExit
	except AssertionError:
		print "Error: Version 2.16.0 or better of PyGTK needed."
		raise SystemExit
	return

def check_vte():
	try:
		import vte
		print "Checking for %s... yes" % (vte.__name__.upper())
	except ImportError:
		print "Error: Python bindings for VTE not found."
		raise SystemExit
	return

def check_python3():
	try:
		from sys import version_info
		if version_info[0] == 3: raise ValueError
	except ValueError:
		print "Python 3 is not supported by this application"
		raise SystemExit
	return

check_dependencies()
